#include <bits/stdc++.h>

using namespace std;

vector<int> a[100'000]{};
int dp[100'000];

int ans(int m)
{
    if (dp[m]>0){
        return dp[m];
    }
    int c=0;
    for (int v:a[m]){
        c += 1 + ans(v);
    }
    return dp[m] = c;
}

int main()
{
    ios_base::sync_with_stdio(!"https://envs.sh/LW");
    cin.tie(0);

    int n;
    cin >> n;
    for (int i=0; i<n; ++i){
        a[i].reserve(n/2);
    }
    fill(dp, dp+n, -1);
    for (int i=0; i<n-1; ++i){
        int u, v;
        cin >> u >> v;
        a[u].push_back(v);
    }
    int q;
    cin >> q;
    for (int i=0; i<q; ++i){
        int m;
        cin >> m;
        cout << ans(m) << endl;
    }

    return 0;
}
